/////////////////////////////// Includes //////////////////////////////////////

#include "stdafx.h"
#include "XP_LEVENSHTEIN2.h"
#include "ld.h"

/////////////////////////////// Implementation ////////////////////////////////

#define DataIn_PARAMETER_INDEX1  0
#define DataIn_PARAMETER_INDEX2  1
#define DataOut_PARAMETER_INDEX 2

BEGIN_IMPLEMENT_XP_PARAMETERS(CXP_LEVENSHTEIN2)
  XP_INPUT_PARAMETER (1, NULL, XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR, TRUE, FALSE, XP_PT_ASCIITEXT)
  XP_INPUT_PARAMETER (2, NULL, XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR, TRUE, FALSE, XP_PT_ASCIITEXT)
  XP_OUTPUT_PARAMETER(3, NULL, XP_ALLOW_INT4, TRUE, FALSE)
END_IMPLEMENT_XP_PARAMETERS(CXP_LEVENSHTEIN2)

void CXP_LEVENSHTEIN2::DisplayUsage()
{
  SendInfoMsg("USAGE: XP_LEVENSHTEIN2 @word1, @word2, @result OUTPUT");
}

BOOL CXP_LEVENSHTEIN2::Run()
{
  //Validate our parameters  
  XP_ASSERT(m_pParameterData);

  //Get the input parameter, note that this XP only operates on ASCII data and not UNICODE
  char* szBuffer1 = XP_ASCIITEXT(m_pParameterData[DataIn_PARAMETER_INDEX1].m_Data);
  char* szBuffer2 = XP_ASCIITEXT(m_pParameterData[DataIn_PARAMETER_INDEX2].m_Data);

  //Distance Lev;
  //int ret=Lev.LD(szBuffer1, szBuffer2);
  int ret=distance(szBuffer1, szBuffer2);;
 
  //Return the data in the output parameter
  ParamSetOutput(DataOut_PARAMETER_INDEX+1, (unsigned char *)&ret, 4, FALSE);

  //We got here, so the running of the XP was successful   m_pParameterData[DataOut_PARAMETER_INDEX].m_cbMaxLen
  return TRUE;
}
