Imports System
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlServer
Imports System.Data.SqlTypes

Partial Public Class StoredProcedures
    '*******************************
    '*** Get minimum of three values
    '*******************************

    Private Shared Function Minimum(ByVal a As Integer, ByVal b As Integer, ByVal c As Integer) As Integer
        Dim mi As Integer
        mi = a
        If b < mi Then
            mi = b
        End If
        If c < mi Then
            mi = c
        End If
        Minimum = mi
    End Function
    '********************************
    '*** Compute Levenshtein Distance
    '********************************
    <SqlProcedure()> _
    Public Shared Sub Levenshtein(ByVal s As SqlString, ByVal t As SqlString, ByRef LD As SqlInt32)
        Dim m As Integer ' length of t
        Dim n As Integer ' length of s
        Dim i As Integer ' iterates through s
        Dim j As Integer ' iterates through t
        Dim s_i As String ' ith character of s
        Dim t_j As String ' jth character of t
        Dim cost As Integer ' cost

        ' Step 1

        n = Len(s.ToString)
        m = Len(t.ToString)
        If n = 0 Then
            LD = m
            Exit Sub
        End If
        If m = 0 Then
            LD = n
            Exit Sub
        End If
        Dim d(0 To n, 0 To m) As Integer

        ' Step 2

        For i = 0 To n
            d(i, 0) = i
        Next i

        For j = 0 To m
            d(0, j) = j
        Next j

        ' Step 3

        For i = 1 To n

            s_i = Mid$(s.ToString, i, 1)

            ' Step 4

            For j = 1 To m

                t_j = Mid$(t.ToString, j, 1)

                ' Step 5

                If s_i = t_j Then
                    cost = 0
                Else
                    cost = 1
                End If

                ' Step 6

                d(i, j) = Minimum(d(i - 1, j) + 1, d(i, j - 1) + 1, d(i - 1, j - 1) + cost)
            Next j
        Next i

        ' Step 7

        LD = d(n, m)
        Erase d
    End Sub
End Class
