
--Sample code for testing XP_ASTRO

--1) Is this XP going to replace an older version?
--	If so, then drop the older version's registration
--	Otherwise the next statements might be commented
if OBJECT_ID('XP_ASTRO_DATE2JULIAN') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_DATE2JULIAN'
	END

if OBJECT_ID('XP_ASTRO_JULIAN2DATE') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_JULIAN2DATE'
	END

if OBJECT_ID('XP_ASTRO_DELTAT') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_DELTAT'
	END

if OBJECT_ID('XP_ASTRO_SPRING_EQUINOX') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_SPRING_EQUINOX'
	END

if OBJECT_ID('XP_ASTRO_SUMMER_SOLSTICE') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_SUMMER_SOLSTICE'
	END

if OBJECT_ID('XP_ASTRO_AUTUMN_EQUINOX') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_AUTUMN_EQUINOX'
	END

if OBJECT_ID('XP_ASTRO_WINTER_SOLSTICE') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_WINTER_SOLSTICE'
	END

if OBJECT_ID('XP_ASTRO_MOONPHASEK') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_MOONPHASEK'
	END

if OBJECT_ID('XP_ASTRO_MOONPHASE') IS NOT NULL
	BEGIN
	DBCC XP_ASTRO(FREE)
	EXEC master..sp_dropextendedproc 'XP_ASTRO_MOONPHASE'
	END



--2) Copy XP_ASTRO.dll to SQL Server's Binn folder
-- Usually C:\Program Files\Microsoft SQL Server\MSSQL\Binn

--3) Register XP
EXEC master..sp_addextendedproc 'XP_ASTRO_DATE2JULIAN', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_JULIAN2DATE', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_DELTAT', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_SPRING_EQUINOX', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_SUMMER_SOLSTICE', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_AUTUMN_EQUINOX', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_WINTER_SOLSTICE', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_MOONPHASEK', 'XP_ASTRO.dll'
EXEC master..sp_addextendedproc 'XP_ASTRO_MOONPHASE', 'XP_ASTRO.dll'


--Testing the XP
EXEC master..XP_ASTRO_DATE2JULIAN
EXEC master..XP_ASTRO_JULIAN2DATE
EXEC master..XP_ASTRO_DELTAT
EXEC master..XP_ASTRO_SPRING_EQUINOX
EXEC master..XP_ASTRO_SUMMER_SOLSTICE
EXEC master..XP_ASTRO_AUTUMN_EQUINOX
EXEC master..XP_ASTRO_WINTER_SOLSTICE
EXEC master..XP_ASTRO_MOONPHASEK
EXEC master..XP_ASTRO_MOONPHASE

DECLARE @curtime datetime
SELECT @curtime = GETDATE()
PRINT @curtime
DECLARE @Julian float
EXEC master..XP_ASTRO_DATE2JULIAN @curtime, @Julian OUTPUT
PRINT @Julian

DECLARE @curtime4 smalldatetime
SELECT @curtime4 = GETDATE()
PRINT @curtime4
DECLARE @Julian2 float
EXEC master..XP_ASTRO_DATE2JULIAN @curtime4, @Julian2 OUTPUT
PRINT @Julian2

DECLARE @outcurtime datetime
EXEC master..XP_ASTRO_JULIAN2DATE @Julian, @outcurtime OUTPUT
PRINT @outcurtime

DECLARE @outcurtime2 smalldatetime
EXEC master..XP_ASTRO_JULIAN2DATE @Julian2, @outcurtime2 OUTPUT
PRINT @outcurtime2

DECLARE @deltaT float
EXEC master..XP_ASTRO_DELTAT @Julian2, @deltaT OUTPUT
PRINT @deltaT

DECLARE @SpringEquinox float
EXEC master..XP_ASTRO_SPRING_EQUINOX 2005, @SpringEquinox OUTPUT
DECLARE @SpringEquinoxdt datetime
EXEC master..XP_ASTRO_JULIAN2DATE @SpringEquinox, @SpringEquinoxdt OUTPUT
PRINT 'Spring Equinox in 2005 (TD) ' + CAST(@SpringEquinoxdt AS varchar)

--lets convert the above date to a value in Universal Time (aka Civil Time)
EXEC master..XP_ASTRO_DELTAT @SpringEquinox, @deltaT OUTPUT
SELECT @SpringEquinoxdt = DATEADD(second, -@deltaT, @SpringEquinoxdt)
PRINT 'Spring Equinox in 2005 (UT): ' + CAST(@SpringEquinoxdt AS varchar)

DECLARE @SummerSolstice float
EXEC master..XP_ASTRO_SUMMER_SOLSTICE 2005, @SummerSolstice OUTPUT
DECLARE @SummerSolsticedt datetime
EXEC master..XP_ASTRO_JULIAN2DATE @SummerSolstice, @SummerSolsticedt OUTPUT
PRINT 'Summer Solstice in 2005 (TD) ' + CAST(@SummerSolsticedt AS varchar)

DECLARE @AutumnEquinox float
EXEC master..XP_ASTRO_AUTUMN_EQUINOX 2005, @AutumnEquinox OUTPUT
DECLARE @AutumnEquinoxdt datetime
EXEC master..XP_ASTRO_JULIAN2DATE @AutumnEquinox, @AutumnEquinoxdt OUTPUT
PRINT 'Autumn (Fall) Equinox in 2005 (TD) ' + CAST(@AutumnEquinoxdt AS varchar)

DECLARE @WinterSolstice float
EXEC master..XP_ASTRO_WINTER_SOLSTICE 2005, @WinterSolstice OUTPUT
DECLARE @WinterSolsticedt datetime
EXEC master..XP_ASTRO_JULIAN2DATE @WinterSolstice, @WinterSolsticedt OUTPUT
PRINT 'Winter Solstice in 2005 (TD) ' + CAST(@WinterSolsticedt AS varchar)

DECLARE @MoonPhaseDate float
SELECT @MoonPhaseDate = 1977.13
DECLARE @MoonPhaseK float
EXEC master..XP_ASTRO_MOONPHASEK @MoonPhaseDate, @MoonPhaseK OUTPUT
PRINT @MoonPhaseK

DECLARE @MoonPhase float
SELECT @MoonPhaseK = -283.0
EXEC master..XP_ASTRO_MOONPHASE @MoonPhaseK, @MoonPhase OUTPUT
DECLARE @MoonPhasedt datetime
EXEC master..XP_ASTRO_JULIAN2DATE @MoonPhase, @MoonPhasedt OUTPUT
PRINT 'New Moon in February 1977 (TD) ' + CAST(@MoonPhasedt AS varchar)

SELECT @MoonPhaseK = 544.75
EXEC master..XP_ASTRO_MOONPHASE @MoonPhaseK, @MoonPhase OUTPUT
EXEC master..XP_ASTRO_JULIAN2DATE @MoonPhase, @MoonPhasedt OUTPUT
PRINT 'First Last Quarter of A.D. 2044 (TD) ' + CAST(@MoonPhasedt AS varchar)
