#include "stdafx.h"
#include "..\xp++\xp_pp.h"
#include "XPHash.h"
#include "XPHMAC.h"
#include "XPSymmetricEncryption.h"
#include "XPSignatures.h"
#include "XPAsymmetricEncryption.h"

IMPLEMENT_VERSION_XP()                                         //Support the optional __GetXpVersion function

IMPLEMENT_XP(XP_CRC32_HASH,             CCRC32HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_MD2_HASH,               CMD2HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_MD4_HASH,               CMD4HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_MD5_HASH,               CMD5HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_SHA1_HASH,              CSHA1HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_SHA256_HASH,            CSHA256HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_SHA384_HASH,            CSHA384HashExtendedStoredProcedure)
IMPLEMENT_XP(XP_SHA512_HASH,            CSHA512HashExtendedStoredProcedure)

IMPLEMENT_XP(XP_MD2_HMAC,               CMD2HMACExtendedStoredProcedure)
IMPLEMENT_XP(XP_MD4_HMAC,               CMD4HMACExtendedStoredProcedure)
IMPLEMENT_XP(XP_MD5_HMAC,               CMD5HMACExtendedStoredProcedure)
IMPLEMENT_XP(XP_SHA1_HMAC,              CSHA1HMACExtendedStoredProcedure)
                                        
IMPLEMENT_XP(XP_RC2_ENCRYPT,            CRC2SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_RC4_ENCRYPT,            CRC4SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_RC5_ENCRYPT,            CRC5SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_DES_ENCRYPT,            CDESSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_3DES112_ENCRYPT,        C3DES112SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_3DES_ENCRYPT,           C3DESSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_DESX_ENCRYPT,           CDESXSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_AES128_ENCRYPT,         CAES128SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_AES192_ENCRYPT,         CAES192SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_AES256_ENCRYPT,         CAES256SymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_SKIPJACK_ENCRYPT,       CSkipjackSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_CYLINK_MEK_ENCRYPT,     CCYLINK_MEKSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_HELIX_ENCRYPT,          CHelixSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_BLOWFISH_ENCRYPT,       CBlowfishSymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_TEA_ENCRYPT,            CTEASymmetricEncryptionExtendedStoredProcedure)
                                        
IMPLEMENT_XP(XP_RC2_DECRYPT,            CRC2SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_RC4_DECRYPT,            CRC4SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_RC5_DECRYPT,            CRC5SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_DES_DECRYPT,            CDESSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_3DES112_DECRYPT,        C3DES112SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_3DES_DECRYPT,           C3DESSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_DESX_DECRYPT,           CDESXSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_AES128_DECRYPT,         CAES128SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_AES192_DECRYPT,         CAES192SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_AES256_DECRYPT,         CAES256SymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_SKIPJACK_DECRYPT,       CSkipjackSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_CYLINK_MEK_DECRYPT,     CCYLINK_MEKSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_HELIX_DECRYPT,          CHelixSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_BLOWFISH_DECRYPT,       CBlowfishSymmetricDecryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_TEA_DECRYPT,            CTEASymmetricDecryptionExtendedStoredProcedure)
                                        
IMPLEMENT_XP(XP_RSA_MD2_SIGN,           CRSA_MD2_SignExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_MD4_SIGN,           CRSA_MD4_SignExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_MD5_SIGN,           CRSA_MD5_SignExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_SHA1_SIGN,          CRSA_SHA1_SignExtendedStoredProcedure)
IMPLEMENT_XP(XP_DSA_SIGN,               CDSA_SignExtendedStoredProcedure)
                                        
IMPLEMENT_XP(XP_RSA_MD2_VERIFY,         CRSA_MD2_VerifyExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_MD4_VERIFY,         CRSA_MD4_VerifyExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_MD5_VERIFY,         CRSA_MD5_VerifyExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_SHA1_VERIFY,        CRSA_SHA1_VerifyExtendedStoredProcedure)
IMPLEMENT_XP(XP_DSA_VERIFY,             CDSA_VerifyExtendedStoredProcedure)

IMPLEMENT_XP(XP_RSA_EXPORT_SIGNKEY,     CRSA_ExportSignExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_EXPORT_ENCRYPTKEY,  CRSA_ExportEncryptExtendedStoredProcedure)
IMPLEMENT_XP(XP_DSA_EXPORT,             CDSA_ExportExtendedStoredProcedure)

IMPLEMENT_XP(XP_RSA_ENCRYPT,            CRSAAsymmetricEncryptionExtendedStoredProcedure)
IMPLEMENT_XP(XP_RSA_DECRYPT,            CRSAAsymmetricDecryptionExtendedStoredProcedure)





#ifndef _AFX //MFC defines its own version of DllMain
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD /*fdwReason*/, LPVOID /*lpvReserved*/)
{
  DisableThreadLibraryCalls(hinstDLL);

  return TRUE;
}
#endif

