#ifndef __XPSIGNATURES_H__
#define __XPSIGNATURES_H__

///////////////////// Includes ////////////////////////////////////////////////

#include "..\xp++\xp_pp.h"



//////////////////// Classes /////////////////////////////////////////

class CCryptoAPISignExtendedStoredProcedure : public CExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CCryptoAPISignExtendedStoredProcedure() : m_AlgID(0), m_dwProviderType(NULL) { };

  virtual BOOL Run();

  DECLARE_XP_PARAMETERS()

//Helper functions
  static BOOL CryptAcquireContext(HCRYPTPROV* phProv, LPCTSTR pszContainer, LPCTSTR pszProvider, DWORD dwProvType, DWORD dwFlags);

protected:

//Member variables
  ALG_ID m_AlgID;
  DWORD m_dwProviderType;
};

class CRSA_MD2_SignExtendedStoredProcedure : public CCryptoAPISignExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_MD2_SignExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_MD4_SignExtendedStoredProcedure : public CCryptoAPISignExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_MD4_SignExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_MD5_SignExtendedStoredProcedure : public CCryptoAPISignExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_MD5_SignExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_SHA1_SignExtendedStoredProcedure : public CCryptoAPISignExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_SHA1_SignExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CDSA_SignExtendedStoredProcedure : public CCryptoAPISignExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CDSA_SignExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CCryptoAPIVerifyExtendedStoredProcedure : public CExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CCryptoAPIVerifyExtendedStoredProcedure() : m_AlgID(0), m_dwProviderType(0) { };

  virtual BOOL Run();

  DECLARE_XP_PARAMETERS()

protected:
  ALG_ID m_AlgID;
  DWORD m_dwProviderType;
};

class CRSA_MD2_VerifyExtendedStoredProcedure : public CCryptoAPIVerifyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_MD2_VerifyExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_MD4_VerifyExtendedStoredProcedure : public CCryptoAPIVerifyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_MD4_VerifyExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_MD5_VerifyExtendedStoredProcedure : public CCryptoAPIVerifyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_MD5_VerifyExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_SHA1_VerifyExtendedStoredProcedure : public CCryptoAPIVerifyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_SHA1_VerifyExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CDSA_VerifyExtendedStoredProcedure : public CCryptoAPIVerifyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CDSA_VerifyExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CCryptoAPIExportPublicKeyExtendedStoredProcedure : public CExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CCryptoAPIExportPublicKeyExtendedStoredProcedure() : m_dwProviderType(NULL), m_dwKeySpec(0) { };

  virtual BOOL Run();

  DECLARE_XP_PARAMETERS()

protected:
//Member variables
  DWORD m_dwProviderType;
  DWORD m_dwKeySpec;
};

class CRSA_ExportSignExtendedStoredProcedure : public CCryptoAPIExportPublicKeyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_ExportSignExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CRSA_ExportEncryptExtendedStoredProcedure : public CCryptoAPIExportPublicKeyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CRSA_ExportEncryptExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};

class CDSA_ExportExtendedStoredProcedure : public CCryptoAPIExportPublicKeyExtendedStoredProcedure
{
public:
//Constructors / Destructors
  CDSA_ExportExtendedStoredProcedure();

//Methods
  virtual void DisplayUsage();
};


#endif //__XPSIGNATURES_H__
