#ifndef __XP_DISKLOGPROC_H__

///////////////////// Includes ////////////////////////////////////////////////

#include "..\xp++\xp_pp.h"



//////////////////// Classes /////////////////////////////////////////

class CDiskLogExtendedStoredProcedure : public CExtendedStoredProcedure
{
public:
  virtual void DisplayUsage(); //Override used to display help about this XP
  virtual BOOL Run();          //Override to do the real work of this XP

  DECLARE_XP_PARAMETERS()

protected:
  virtual BOOL AutoConvertParameters(); //inherited from parent class

  static BOOL GetAbrStringDayOfWeek(LCID lcid, const SYSTEMTIME& st, LPSTR pszBuf, int nBufSize);
  static BOOL GetFullStringDayOfWeek(LCID lcid, const SYSTEMTIME& st, LPSTR pszBuf, int nBufSize);
  static BOOL GetAbrStringMonth(LCID lcid, const SYSTEMTIME& st, LPSTR pszBuf, int nBufSize);
  static BOOL GetFullStringMonth(LCID lcid, const SYSTEMTIME& st, LPSTR pszBuf, int nBufSize);
  static BOOL MapReplaceableStrings(LCID lcid, const SYSTEMTIME& st, LPCSTR pszInputString, LPSTR pszOutputString, int nOutputStringLength);
  static BOOL GetShortDateRepresentation(LCID lcid, const SYSTEMTIME& st, LPSTR pszBuf, int nBufSize);
  static BOOL GetLongDateRepresentation(LCID lcid, const SYSTEMTIME& st, LPSTR pszBuf, int nBufSize);

  static BOOL GetAbrStringDayOfWeek(LCID lcid, const SYSTEMTIME& st, LPWSTR pszBuf, int nBufSize);
  static BOOL GetFullStringDayOfWeek(LCID lcid, const SYSTEMTIME& st, LPWSTR pszBuf, int nBufSize);
  static BOOL GetAbrStringMonth(LCID lcid, const SYSTEMTIME& st, LPWSTR pszBuf, int nBufSize);
  static BOOL GetFullStringMonth(LCID lcid, const SYSTEMTIME& st, LPWSTR pszBuf, int nBufSize);
  static BOOL MapReplaceableStrings(LCID lcid, const SYSTEMTIME& st, LPCWSTR pszInputString, LPWSTR pszOutputString, int nOutputStringLength);
  static BOOL GetShortDateRepresentation(LCID lcid, const SYSTEMTIME& st, LPWSTR pszBuf, int nBufSize);
  static BOOL GetLongDateRepresentation(LCID lcid, const SYSTEMTIME& st, LPWSTR pszBuf, int nBufSize);

  static int DaysInMonth(int Month, BOOL IsLeap);
  static BOOL IsLeap(int Year);
  static int DaysSinceJan0(const SYSTEMTIME& st);
  static int GetWeekOfYear(const SYSTEMTIME& st);
};

#endif //__XP_DISKLOGPROC_H__
