/////////////////////////////// Includes //////////////////////////////////////

#include "stdafx.h"
#include "XP_DISKSPACEProc.h"


/////////////////////////////// Implementation ////////////////////////////////

// The implementation of the actual XP_DISKSPACE XP itself

#define DISKSPACE_DRIVELETTER_INDEX 0
#define DISKSPACE_DISKSPACE_INDEX   1

BEGIN_IMPLEMENT_XP_PARAMETERS(CDiskSpaceExtendedStoredProcedure)
  XP_INPUT_PARAMETER(1, NULL, XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR | XP_ALLOW_NTEXT | XP_ALLOW_NVARCHAR, FALSE, FALSE, XP_PT_TTEXT)
  XP_OUTPUT_PARAMETER(2, NULL, XP_ALLOW_INT4, TRUE, FALSE)
END_IMPLEMENT_XP_PARAMETERS(CDiskSpaceExtendedStoredProcedure)

void CDiskSpaceExtendedStoredProcedure::DisplayUsage()
{
  SendInfoMsg("USAGE: XP_DISKSPACE @DriveLetter @DiskSpaceMB OUTPUT");
}

BOOL CDiskSpaceExtendedStoredProcedure::Run()
{
  //Validate our parmeters  
  XP_ASSERT(m_pParameterData);

  //Local buffer we use for reporting messages back to ODS
  char szErrorMsg[2048];

  //Get the parameters
  TCHAR* pszDriveLetter = XP_TTEXT(m_pParameterData[DISKSPACE_DRIVELETTER_INDEX].m_Data);
  XP_ASSERT(pszDriveLetter);

  //Call GetDiskFreeSpaceEx
  ULARGE_INTEGER i64FreeBytesToCaller;
  ULARGE_INTEGER i64TotalBytes;
  ULARGE_INTEGER i64FreeBytes;
  BOOL bSuccess = GetDiskFreeSpaceEx(pszDriveLetter, &i64FreeBytesToCaller, &i64TotalBytes, &i64FreeBytes);
  if (bSuccess)
  {
    //Always return the space left on the drive in megabytes
    DBINT nSpaceLeft = (DBINT) (((__int64) i64FreeBytes.QuadPart) / 1048576);

    //Return the data in the output parameter    
    ParamSetOutput(DISKSPACE_DISKSPACE_INDEX+1, (BYTE*) &nSpaceLeft, sizeof(nSpaceLeft), FALSE);
  }
  else
  {
    sprintf(szErrorMsg, "%s: Failed in call to GetDiskSpaceEx, Error:%d", m_szFunctionName, GetLastError());
    SendErrorMsg(szErrorMsg);
  }


  return bSuccess;
}

