
--Sample code for testing XP_GIS

--1) Is this XP going to replace an older version?
--	If so, then drop the older version's registration
--	Otherwise the next statements might be commented
if OBJECT_ID('XP_GIS_LL2UTM') IS NOT NULL
	BEGIN
	DBCC XP_GIS(FREE)
	EXEC master..sp_dropextendedproc 'XP_GIS_LL2UTM'
	END

if OBJECT_ID('XP_GIS_UTM2LL') IS NOT NULL
	BEGIN
	DBCC XP_GIS(FREE)
	EXEC master..sp_dropextendedproc 'XP_GIS_UTM2LL'
	END

if OBJECT_ID('XP_GIS_DATUMINFO') IS NOT NULL
	BEGIN
	DBCC XP_GIS(FREE)
	EXEC master..sp_dropextendedproc 'XP_GIS_DATUMINFO'
	END

if OBJECT_ID('XP_GIS_ELLIPSOIDINFO') IS NOT NULL
	BEGIN
	DBCC XP_GIS(FREE)
	EXEC master..sp_dropextendedproc 'XP_GIS_ELLIPSOIDINFO'
	END

if OBJECT_ID('XP_GIS_DISTANCE_BETWEEN') IS NOT NULL
	BEGIN
	DBCC XP_GIS(FREE)
	EXEC master..sp_dropextendedproc 'XP_GIS_DISTANCE_BETWEEN'
	END

if OBJECT_ID('XP_GIS_DATUMTRANSFORM') IS NOT NULL
	BEGIN
	DBCC XP_GIS(FREE)
	EXEC master..sp_dropextendedproc 'XP_GIS_DATUMTRANSFORM'
	END


--2) Copy XP_GIS.dll to SQL Server's Binn folder
-- Usually C:\Program Files\Microsoft SQL Server\MSSQL\Binn

--3) Register XP
EXEC master..sp_addextendedproc 'XP_GIS_LL2UTM', 'XP_GIS.dll'
EXEC master..sp_addextendedproc 'XP_GIS_UTM2LL', 'XP_GIS.dll'
EXEC master..sp_addextendedproc 'XP_GIS_DATUMINFO', 'XP_GIS.dll'
EXEC master..sp_addextendedproc 'XP_GIS_ELLIPSOIDINFO', 'XP_GIS.dll'
EXEC master..sp_addextendedproc 'XP_GIS_DISTANCE_BETWEEN', 'XP_GIS.dll'
EXEC master..sp_addextendedproc 'XP_GIS_DATUMTRANSFORM', 'XP_GIS.dll'

--Testing the XP
DECLARE @Lat float
SELECT @Lat = 52.5
DECLARE @Long float
SELECT @Long = -6
DECLARE @RefEllipsoid int
SELECT @RefEllipsoid = 26 --Use the WGS 84 Reference ellipsoid
DECLARE @Northing float
DECLARE @Easting float
DECLARE @UTMZone varchar(10)
--EXEC master..XP_GIS_LL2UTM
EXEC master..XP_GIS_LL2UTM @Lat, @Long, @RefEllipsoid, @Northing OUTPUT, @Easting OUTPUT, @UTMZone OUTPUT
PRINT @Northing
PRINT @Easting
PRINT @UTMZone

--EXEC master..XP_GIS_UTM2LL 
EXEC master..XP_GIS_UTM2LL @Northing, @Easting, @UTMZone, @RefEllipsoid, @Lat OUTPUT, @Long OUTPUT
PRINT @Lat
PRINT @Long

--EXEC master..XP_GIS_DATUMINFO 
DECLARE @DX float
DECLARE @DY float
DECLARE @DZ float
DECLARE @EX float
DECLARE @EY float
DECLARE @EZ float
DECLARE @Datum int
SELECT @Datum = 0
DECLARE @DatumName varchar(200)
DECLARE @Satellites int
EXEC master..XP_GIS_DATUMINFO @Datum, @DatumName OUTPUT, @RefEllipsoid OUTPUT, @DX OUTPUT, @DY OUTPUT, @DZ OUTPUT, @EX OUTPUT, @EY OUTPUT, @EZ OUTPUT, @Satellites OUTPUT
PRINT @DatumName
PRINT @RefEllipsoid
PRINT @DX
PRINT @DY
PRINT @DZ
PRINT @EX
PRINT @EY
PRINT @EZ
PRINT @Satellites

--EXEC master..XP_GIS_ELLIPSOIDINFO 
DECLARE @EllipsoidName varchar(200)
DECLARE @EquatorialRadius float
DECLARE @OneOverF float
SELECT @RefEllipsoid = 0
EXEC master..XP_GIS_ELLIPSOIDINFO @RefEllipsoid, @EllipsoidName OUTPUT, @EquatorialRadius OUTPUT, @OneOverF OUTPUT
PRINT @EllipsoidName
PRINT @EquatorialRadius
PRINT @OneOverF

DECLARE @Lon1 float
SELECT @Lon1 = 2.3372222222222222222222222222222 --The longitude of Observatoire de Paris
DECLARE @Lat1 float
SELECT @Lat1 = 48.836388888888888888888888888889 --The latitude of Observatoire de Paris
DECLARE @Lon2 float
SELECT @Lon2 = -77.065555555555555555555555555556 --The longitude of the U.S. Naval Observatory at Washington, D.C.
DECLARE @Lat2 float
SELECT @Lat2 = 38.921388888888888888888888888889 --The latitude of U.S. Naval Observatory at Washington, D.C.
--EXEC master..XP_GIS_DISTANCE_BETWEEN
DECLARE @DistanceBetween float
SELECT @RefEllipsoid = 27 --Use the IAU 1976 ellipsoid
EXEC master..XP_GIS_DISTANCE_BETWEEN @Lat1, @Lon1, @Lat2, @Lon2, @RefEllipsoid, @DistanceBetween OUTPUT
PRINT @DistanceBetween

EXEC master..XP_GIS_DATUMTRANSFORM
SELECT @Lon1 = -6
SELECT @Lat1 = 52.5
DECLARE @FromDatum int
SELECT @FromDatum = 216  --Specify the from location in the WGS 1984 (Global Definition) datum
DECLARE @ToDatum int
SELECT @ToDatum = 0   --Convert to the Adindan (Burkina Faso) datum
DECLARE @FromHeight float
SELECT @FromHeight = 0
DECLARE @ToHeight float
SELECT @ToHeight = 0
--EXEC master..XP_GIS_DATUMTRANSFORM @Lat, @Long, @FromHeight, @FromDatum, @ToDatum, @Lat2 OUTPUT, @Lon2 OUTPUT, @ToHeight OUTPUT
--PRINT @Lat2
--PRINT @Lon2
--PRINT @ToHeight

SELECT @Lon1 = -100
SELECT @Lat1 = 30
SELECT @FromDatum = 131 --Specify the from location in the NAD27 Conus datum 
SELECT @ToDatum = 216   --Convert to the WGS 1984 (Global Definition) datum
SELECT @FromHeight = 232
EXEC master..XP_GIS_DATUMTRANSFORM @Lat1, @Lon1, @FromHeight, @FromDatum, @ToDatum, @Lat2 OUTPUT, @Lon2 OUTPUT, @ToHeight OUTPUT
PRINT @Lat2
PRINT @Lon2
PRINT @ToHeight
--Let's try the inverse transform to see the result
EXEC master..XP_GIS_DATUMTRANSFORM @Lat2, @Lon2, @ToHeight, @ToDatum, @FromDatum, @Lat1 OUTPUT, @Lon1 OUTPUT, @FromHeight OUTPUT
PRINT @Lat1
PRINT @Lon1
PRINT @ToHeight




SELECT @Lat = 30.274672222222222222222222222222  --The latitude of Texas Capitol Building in NAD83
SELECT @Long = -97.740330555555555555555555555556 --The longitude of Texas Capitol Building in NAD83
SELECT @RefEllipsoid = 21 --Use the GRS_80 Reference ellipsoid on which NAD83 is based
EXEC master..XP_GIS_LL2UTM @Lat, @Long, @RefEllipsoid, @Northing OUTPUT, @Easting OUTPUT, @UTMZone OUTPUT
PRINT @Northing
PRINT @Easting
PRINT @UTMZone
