/////////////////////////////// Includes //////////////////////////////////////

#include "stdafx.h"
#include "XP_NETSENDProcs.h"



/////////////////////////////// Implementation ////////////////////////////////

#define SEND_MESSAGE_INDEX 0
#define SEND_TO_INDEX      1
#define SEND_FROM_INDEX    2

BEGIN_IMPLEMENT_XP_PARAMETERS(CNetSendExtendedStoredProcedure)
  XP_INPUT_PARAMETER(0, "@Message", XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR | XP_ALLOW_NTEXT | XP_ALLOW_NVARCHAR, FALSE, FALSE, XP_PT_UNICODETEXT)
  XP_INPUT_PARAMETER(0, "@To",      XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR | XP_ALLOW_NTEXT | XP_ALLOW_NVARCHAR, FALSE, FALSE, XP_PT_UNICODETEXT)
  XP_INPUT_PARAMETER(0, "@From",    XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR | XP_ALLOW_NTEXT | XP_ALLOW_NVARCHAR, FALSE, TRUE,  XP_PT_UNICODETEXT)
END_IMPLEMENT_XP_PARAMETERS(CNetSendExtendedStoredProcedure)

void CNetSendExtendedStoredProcedure::DisplayUsage()
{
  SendInfoMsg("USAGE: XP_NET_SEND @Message=message, @To=Recipient, [@From=Sender]");
}

BOOL CNetSendExtendedStoredProcedure::Run()
{
  //Validate our parmeters  
  XP_ASSERT(m_pParameterData);

  //Get the parameters
  wchar_t* pszMessage = XP_UNICODETEXT(m_pParameterData[SEND_MESSAGE_INDEX].m_Data);
  XP_ASSERT(pszMessage);
  wchar_t* pszTo = XP_UNICODETEXT(m_pParameterData[SEND_TO_INDEX].m_Data);
  XP_ASSERT(pszTo);
  wchar_t* pszFrom = (m_pParameterData[SEND_FROM_INDEX].m_bType != SRVNULL) ? XP_UNICODETEXT(m_pParameterData[SEND_FROM_INDEX].m_Data) : NULL;

  //Call the "NetMessageBufferSend" function
  NET_API_STATUS status = NetMessageBufferSend(NULL, pszTo, pszFrom, (LPBYTE) pszMessage, (DWORD) (wcslen(pszMessage)*sizeof(wchar_t)));
  if (status != NERR_Success)
  {
    //Report the error
    char szErrorMsg[2048];
    sprintf(szErrorMsg, "%s: Error calling NetMessageBufferSend, Error:%d", m_szFunctionName, status);
    SendErrorMsg(szErrorMsg);
  }

  return (status == NERR_Success);
}



#define ADD_MESSAGE_NAME_INDEX 0

BEGIN_IMPLEMENT_XP_PARAMETERS(CNetAddNameExtendedStoredProcedure)
  XP_INPUT_PARAMETER(1, NULL, XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR | XP_ALLOW_NTEXT | XP_ALLOW_NVARCHAR, FALSE, FALSE, XP_PT_UNICODETEXT)
END_IMPLEMENT_XP_PARAMETERS(CNetAddNameExtendedStoredProcedure)

void CNetAddNameExtendedStoredProcedure::DisplayUsage()
{
  SendInfoMsg("USAGE: XP_NET_ADDNAME @Name");
}

BOOL CNetAddNameExtendedStoredProcedure::Run()
{
  //Validate our parmeters  
  XP_ASSERT(m_pParameterData);

  //Get the parameters
  wchar_t* pszMessageName = XP_UNICODETEXT(m_pParameterData[ADD_MESSAGE_NAME_INDEX].m_Data);
  XP_ASSERT(pszMessageName);

  //Call the "NetMessageNameAdd" function
  NET_API_STATUS status = NetMessageNameAdd(NULL, pszMessageName);
  if (status != NERR_Success)
  {
    //Report the error
    char szErrorMsg[2048];
    sprintf(szErrorMsg, "%s: Error calling NetMessageNameAdd, Error:%d", m_szFunctionName, status);
    SendErrorMsg(szErrorMsg);
  }

  return (status == NERR_Success);
}



#define DELETE_MESSAGE_NAME_INDEX 0

BEGIN_IMPLEMENT_XP_PARAMETERS(CNetDeleteNameExtendedStoredProcedure)
  XP_INPUT_PARAMETER(1, NULL, XP_ALLOW_BIGVARCHAR | XP_ALLOW_BIGCHAR | XP_ALLOW_TEXT | XP_ALLOW_VARCHAR | XP_ALLOW_NTEXT | XP_ALLOW_NVARCHAR, FALSE, FALSE, XP_PT_UNICODETEXT)
END_IMPLEMENT_XP_PARAMETERS(CNetDeleteNameExtendedStoredProcedure)

void CNetDeleteNameExtendedStoredProcedure::DisplayUsage()
{
  SendInfoMsg("USAGE: XP_NET_DELNAME @Name");
}

BOOL CNetDeleteNameExtendedStoredProcedure::Run()
{
  //Validate our parmeters  
  XP_ASSERT(m_pParameterData);

  //Get the parameters
  wchar_t* pszMessageName = XP_UNICODETEXT(m_pParameterData[DELETE_MESSAGE_NAME_INDEX].m_Data);
  XP_ASSERT(pszMessageName);

  //Call the "NetMessageNameDel" function
  NET_API_STATUS status = NetMessageNameDel(NULL, pszMessageName);
  if (status != NERR_Success)
  {
    //Report the error
    char szErrorMsg[2048];
    sprintf(szErrorMsg, "%s: Error calling NetMessageNameDel, Error:%d", m_szFunctionName, status);
    SendErrorMsg(szErrorMsg);
  }

  return (status == NERR_Success);
}


