/////////////////////////////// Includes //////////////////////////////////////
//based on Ken Christensen's rawsend.c
#include "stdafx.h"
#include "XP_RAWIP.h"
#include <winsock2.h>// Winsock 2
#include <ws2tcpip.h>// Winsock 2 

/////////////////////////////// Implementation ////////////////////////////////

#define DataIn_PARAMETER_INDEX   0

unsigned char Hex2Dec(char HexInput1, char HexInput2){
  char 
hx[16]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
  unsigned char intcounter, result=0;
  for (intcounter=0;intcounter<16; intcounter++){
	if (hx[intcounter]==toupper(HexInput1))
		result+=intcounter*16;
	if (hx[intcounter]==toupper(HexInput2))
		result+=intcounter;
  }
  return (result);
}

BEGIN_IMPLEMENT_XP_PARAMETERS(CXP_RAWIP)
  XP_INPUT_PARAMETER (1, NULL, XP_ALLOW_ANY, TRUE, FALSE, XP_PT_TTEXT)
END_IMPLEMENT_XP_PARAMETERS(CXP_RAWIP)

void CXP_RAWIP::DisplayUsage()
{
  SendInfoMsg("USAGE: XP_RAWIP @RAWPACKETDATA");
}

BOOL CXP_RAWIP::Run()
{
  //Validate our parmeters  
  XP_ASSERT(m_pParameterData);

  //Local buffer we use for reporting messages back to ODS
  char szErrorMsg[2048];
  WORD wVersionRequested = MAKEWORD(1,1); // Stuff for WSA functions
  WSADATA wsaData;                        // Stuff for WSA functions
  unsigned int         dest_s;            // Destination socket descriptor
  struct sockaddr_in   dest_addr;         // Destination Internet address
  int                  mess_len;          // Message length
  unsigned char        mess_buf[1500];    //get input, max 1500 bytes
  int ErrorCode=0,flag=1;

  //buffer for input/output
  char* input_buf = XP_ASCIITEXT(m_pParameterData[DataIn_PARAMETER_INDEX].m_Data); 

  if (m_pParameterData[DataIn_PARAMETER_INDEX].m_cbActualLen>3000)
	{
		sprintf(szErrorMsg, "Input data must be less than or equal 1500 bytes.");
        SendErrorMsg(szErrorMsg);
        return FALSE;
	}

  if (m_pParameterData[DataIn_PARAMETER_INDEX].m_cbActualLen<92)
	{
		sprintf(szErrorMsg, "Input data must be greater than or equal 46 bytes.");
        SendErrorMsg(szErrorMsg);
        return FALSE;
	}

  //input data must be even in size
  if ((m_pParameterData[DataIn_PARAMETER_INDEX].m_cbActualLen & 1)==1)
	{
		sprintf(szErrorMsg, "Input data must have even length.");
        SendErrorMsg(szErrorMsg);
        return FALSE;
	}

  memset(mess_buf,0, 1500);
  mess_len = m_pParameterData[DataIn_PARAMETER_INDEX].m_cbActualLen/2;

  int i;  
  //make sure input is hex 0=48, 9=57, A=65, Z=90, a=97, z=122
  for (i=0;i<mess_len; i++)
		if ((input_buf[i*2]<48)|
			(input_buf[i*2]>57)&(input_buf[i*2]<65)|
			(input_buf[i*2]>90)&(input_buf[i*2]<97)|
			(input_buf[i*2]>122))
	  	{
		//sprintf(szErrorMsg, "Input data must be in hexadecimal format.");
        SendErrorMsg("Input data must be in hexadecimal format.");
        return FALSE;
		}

  //convert from hex in ASCII chars to binary data
  for (i=0;i<mess_len; i++)
	mess_buf[i]=Hex2Dec(input_buf[i*2], input_buf[i*2+1]);

  // Initialize Winsock
  int iResult = WSAStartup(wVersionRequested, &wsaData);
  if (iResult != NO_ERROR)
  {
	  SendErrorMsg("Error at WSAStartup()");
	return FALSE;
  }
  // Create raw socket for destination
  dest_s = WSASocket(AF_INET, SOCK_RAW, IPPROTO_IP, 0 , 0, 0);
  	if(dest_s==INVALID_SOCKET)
	{
		sprintf(szErrorMsg, "WSASocket failed: %d\n",WSAGetLastError());
        SendErrorMsg(szErrorMsg);
        return FALSE;
	}

  // Fill-in destination socket"s address information
  dest_addr.sin_family = AF_INET;  // Address family to use
  
  ErrorCode=setsockopt(dest_s,IPPROTO_IP,IP_HDRINCL,(char *)&flag,sizeof(int));
  	if(ErrorCode==SOCKET_ERROR)
	{
		sprintf(szErrorMsg, "Set sockopt failed: %d\n",WSAGetLastError());
        SendErrorMsg(szErrorMsg);
        return FALSE;
	}

  // Now send the message to the destination
  ErrorCode=sendto(dest_s, (char *)mess_buf, mess_len, 0,
         (struct sockaddr *)&dest_addr, sizeof(dest_addr));
  	if(ErrorCode==SOCKET_ERROR)//
	{
	    sprintf(szErrorMsg, "sendto failed: %d\n",WSAGetLastError());
        SendErrorMsg(szErrorMsg);
        return FALSE;
		return 4;
	}

  // Close destination socket
  ErrorCode=closesocket(dest_s);
  	if(ErrorCode==SOCKET_ERROR)//
	{
	    sprintf(szErrorMsg, "sendto failed: %d\n",WSAGetLastError());
        SendErrorMsg(szErrorMsg);
        return FALSE;
		return 4;
	}

  // Clean-up Winsock
  WSACleanup();
  SendInfoMsg("Packet sent successfuly.");
  //We got here, so the running of the XP was successful
  return TRUE;
}

