
--Sample code for testing XP_REGEXP_ASCII

--1) Is this XP going to replace an older version?
--	If so, then drop the older version's registration
--	Otherwise the next statements might be commented
if OBJECT_ID('XP_REGEXP_ASCII') IS NOT NULL
	BEGIN
	DBCC XP_REGEXP(FREE)
	EXEC master..sp_dropextendedproc 'XP_REGEXP_ASCII'
	END

if OBJECT_ID('XP_REGEXP_MBCS') IS NOT NULL
	BEGIN
	DBCC XP_REGEXP(FREE)
	EXEC master..sp_dropextendedproc 'XP_REGEXP_MBCS'
	END

if OBJECT_ID('XP_REGEXP_UNICODE') IS NOT NULL
	BEGIN
	DBCC XP_REGEXP(FREE)
	EXEC master..sp_dropextendedproc 'XP_REGEXP_UNICODE'
	END



--2) Copy XP_REGEXP.dll to SQL Server's Binn folder
-- Usually C:\Program Files\Microsoft SQL Server\MSSQL\Binn

--3) Register XP
EXEC master..sp_addextendedproc 'XP_REGEXP_ASCII', 'XP_REGEXP.dll'
EXEC master..sp_addextendedproc 'XP_REGEXP_MBCS', 'XP_REGEXP.dll'
EXEC master..sp_addextendedproc 'XP_REGEXP_UNICODE', 'XP_REGEXP.dll'

--Testing the XP
EXEC master..XP_REGEXP_ASCII
DECLARE @Match bit
DECLARE @RegExAscii varchar(100)
SET @RegExAscii='{[0-9]?[0-9]}:{[0-9][0-9]}'
DECLARE @SourceAscii varchar(100)
SET @SourceAscii='1:57'
EXEC master..XP_REGEXP_ASCII @SourceAscii, @RegExAscii, 1, @match OUTPUT
PRINT @Match
SET @SourceAscii='01/03'
EXEC master..XP_REGEXP_ASCII @SourceAscii, @RegExAscii, 1, @match OUTPUT
PRINT @Match

EXEC master..XP_REGEXP_MBCS
SET @SourceAscii='1:57'
EXEC master..XP_REGEXP_MBCS @SourceAscii, @RegExAscii, 1, @match OUTPUT
PRINT @Match
SET @SourceAscii='01/03'
EXEC master..XP_REGEXP_MBCS @SourceAscii, @RegExAscii, 1, @match OUTPUT
PRINT @Match

DECLARE @RegExUnicode nvarchar(100)
SET @RegExUnicode='{[0-9]?[0-9]}:{[0-9][0-9]}'
DECLARE @SourceUnicode nvarchar(100)
SET @SourceUnicode='1:57'
EXEC master..XP_REGEXP_UNICODE
EXEC master..XP_REGEXP_UNICODE '1:57', '{[0-9]?[0-9]}:{[0-9][0-9]}', 1, @match OUTPUT --This should fail
EXEC master..XP_REGEXP_UNICODE @SourceUnicode, @RegExUnicode, 1, @match OUTPUT
PRINT @Match
SET @SourceUnicode='01/03'
EXEC master..XP_REGEXP_UNICODE @SourceUnicode, @RegExUnicode, 1, @match OUTPUT
PRINT @Match
