//ODS Defines we need for the script
var XPDT_SRVBIGVARCHAR = 0xA7;
var XPDT_SRVBIGCHAR = 0xAF;
var XPDT_SRVTEXT = 0x23;
var XPDT_SRVVARCHAR = 0x27;
var XPDT_SRVNTEXT = 0x63;
var XPDT_SRVNVARCHAR = 0xe7;
var XPDT_SRVINT4 = 0x38;
var XPDT_SRVDATETIME = 0x3d;

//Validate our parameter count
if (SQL.Parameters.Count != 3)
{
  SQL.SendInfoMsg("USAGE: XP_RUNSCRIPT_DISK JScript ThisScriptFilename DirectoryToEnumerate");
  SQL.Quit(false);
}

//Pull out the single parameter we need and verify its data type
var DirectoryParameter = SQL.Parameters(3);
if ((DirectoryParameter.Type != XPDT_SRVBIGVARCHAR) && (DirectoryParameter.Type != XPDT_SRVBIGCHAR) && (DirectoryParameter.Type != XPDT_SRVTEXT) &&
    (DirectoryParameter.Type != XPDT_SRVVARCHAR) && (DirectoryParameter.Type != XPDT_SRVNTEXT) && (DirectoryParameter.Type != XPDT_SRVNVARCHAR))
{
  SQL.SendInfoMsg("The third parameter to this XP which specifies the directory to enumerate must be a string data type");
  SQL.Quit(false);
}

//Describe the recordset we will return
var nullValue;
SQL.Describe("Name", XPDT_SRVTEXT, 255, nullValue);
SQL.Describe("Size (Bytes)", XPDT_SRVINT4, 0, 0);
SQL.Describe("Date Modified", XPDT_SRVDATETIME, 0, 2); //2 corresponds to a VT_DATE of 1 Jan 1900, does not really matter since we will not be relying
                                                       //on a default parameter for the Date Modified column since we will be updating it for each
                                                       //row returned
SQL.Describe("Date Created", XPDT_SRVDATETIME, 0, 2);
SQL.Describe("Date Accessed", XPDT_SRVDATETIME, 0, 2);

//use the built in File System Object to enumerate the specified directory's files collection
var FSO = new ActiveXObject("Scripting.FileSystemObject");
var Folder = FSO.GetFolder(DirectoryParameter.Data);
var FileEnumerator = new Enumerator(Folder.files);
for (; !FileEnumerator.atEnd(); FileEnumerator.moveNext())
{
  //Pull out the current file
  var File = FileEnumerator.item();

  //Set the current row data
  SQL.SetColumnData(1, File.Name);
  SQL.SetColumnData(2, File.Size);
  SQL.SetColumnData(3, File.DateLastModified);
  SQL.SetColumnData(4, File.DateCreated);
  SQL.SetColumnData(5, File.DateLastAccessed);

  //Return the current row to SQL
  SQL.SendRow();
}
