
--Sample code for testing XP_RUNSCRIPT

--1) Is this XP going to replace an older version?
--	If so, then drop the older version's registration
--	Otherwise the next statements might be commented
if OBJECT_ID('XP_RUNSCRIPT_DISK') IS NOT NULL
	BEGIN
	DBCC XP_RUNSCRIPT(FREE)
	EXEC master..sp_dropextendedproc 'XP_RUNSCRIPT_DISK'
	END

if OBJECT_ID('XP_RUNSCRIPT_PARAMETER') IS NOT NULL
	BEGIN
	DBCC XP_RUNSCRIPT(FREE)
	EXEC master..sp_dropextendedproc 'XP_RUNSCRIPT_PARAMETER'
	END

if OBJECT_ID('XP_RUN_ACTIVEX') IS NOT NULL
	BEGIN
	DBCC XP_RUNSCRIPT(FREE)
	EXEC master..sp_dropextendedproc 'XP_RUN_ACTIVEX'
	END


--2) Copy XP_RUNSCRIPT.dll to SQL Server's Binn folder
-- Usually C:\Program Files\Microsoft SQL Server\MSSQL\Binn

--3) Register XP
EXEC master..sp_addextendedproc 'XP_RUNSCRIPT_DISK', 'XP_RUNSCRIPT.dll'
EXEC master..sp_addextendedproc 'XP_RUNSCRIPT_PARAMETER', 'XP_RUNSCRIPT.dll'
EXEC master..sp_addextendedproc 'XP_RUN_ACTIVEX', 'XP_RUNSCRIPT.dll'

--Testing the XP
--EXEC master..XP_RUNSCRIPT_DISK
--EXEC master..XP_RUNSCRIPT_PARAMETER
--EXEC master..XP_RUN_ACTIVEX

DECLARE @testVariable smallmoney
SET @testVariable = 12345

--Try running a script from disk
DECLARE @OutputtestVariable datetime
--Note you should of course change the path to suit your machine
EXEC master..XP_RUNSCRIPT_DISK 'JScript', 'f:\dev\my code\xp\xp_runscript\test\test.js', 34, null, @testVariable, @NamedParameter = @OutputtestVariable OUTPUT
PRINT CAST(@OutputtestVariable as varchar(100))

--Try out running a script from a parameter
EXEC master..XP_RUNSCRIPT_PARAMETER 'JScript', 'SQL.SendInfoMsg("Hello from JScript called via XP_RUNSCRIPT_PARAMETER")'


--Try out the COM object functionality
--Note will need to compile and register the TestRunActiveX VB VB6 ActiveX dll to try this out
EXEC master..XP_RUN_ACTIVEX 'TestRunActiveX.Test1', 'Function1'

--Try out running a VBScript from a file
DECLARE @OutputtestVariable2 int
--Note you should of course change the path to suit your machine
EXEC master..XP_RUNSCRIPT_DISK 'VBScript', 'f:\dev\my code\xp\xp_runscript\test\test.vbs', 34, null, @testVariable, @OutputtestVariable2 OUTPUT
PRINT CAST(@OutputtestVariable2 as varchar(50))
PRINT @OutputtestVariable2