#ifndef __XPPARAMETEROBJ_H__
#define __XPPARAMETEROBJ_H__


#include "resource.h"       // main symbols

/////////////////// Forward reference ////////////////////////
class CRunScriptStoredProcedure;


class ATL_NO_VTABLE CXPParameterObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CXPParameterObj, &CLSID_XPServer>,
  public IDispatchImpl<IXPParameter, &IID_IXPParameter, &LIBID_XP_RUNSCRIPTLib>,
	public ISupportErrorInfoImpl<&IID_IXPParameter>
{
public:
//Constructors / Destructors
	CXPParameterObj();
  ~CXPParameterObj();

DECLARE_NO_REGISTRY()
DECLARE_NOT_AGGREGATABLE(CXPParameterObj)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CXPParameterObj)
  COM_INTERFACE_ENTRY2(IUnknown, IDispatch)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IXPParameter)
  COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

//Member variables
  CRunScriptStoredProcedure* m_pESP;
  int   m_nParameterIndex;
  BYTE  m_bType;
  ULONG m_nMaxLen;
  ULONG m_nActualLen;
  BOOL  m_bNull;
  BYTE* m_pData;

//IXPParameter
	STDMETHOD(get_Type)(XP_DATATYPE* pVal);
	STDMETHOD(get_MaxLen)(long* pVal);
	STDMETHOD(get_ActualLen)(long* pVal);
	STDMETHOD(get_Data)(VARIANT* pVal);
  STDMETHOD(SetOutputData)(VARIANT Data);
	STDMETHOD(get_IsNull)(VARIANT_BOOL* pVal);
	STDMETHOD(get_IsInput)(VARIANT_BOOL* pVal);
	STDMETHOD(get_IsOutput)(VARIANT_BOOL* pVal);

//Other methods
  static HRESULT VariantToXPData(const VARIANT& Data, DBINT desttype, ULONG nMaxLen, const IID& iid, BYTE*& pData, ULONG& cbLen);
};

#endif //__XPPARAMETEROBJ_H__
