#ifndef __XPSCRIPTSITEOBJ_H__
#define __XPSCRIPTSITEOBJ_H__


#include "resource.h"       // main symbols


/////////////////// Forward reference ////////////////////////
class CRunScriptStoredProcedure;
class CXPServerObj;


class ATL_NO_VTABLE CXPRunScriptSite : 
	public CComObjectRootEx<CComMultiThreadModel>,
  public IActiveScriptSite,
  public IActiveScriptSiteInterruptPoll
{
public:
	CXPRunScriptSite();

DECLARE_NO_REGISTRY()
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CXPRunScriptSite)
  COM_INTERFACE_ENTRY2(IUnknown, IActiveScriptSite)
	COM_INTERFACE_ENTRY(IActiveScriptSite)
  COM_INTERFACE_ENTRY(IActiveScriptSiteInterruptPoll)
END_COM_MAP()

public:
//Member variables
  CRunScriptStoredProcedure* m_pESP;

//IActiveScriptSite
  STDMETHOD(GetLCID)(LCID* plcid);
  STDMETHOD(GetItemInfo)(LPCOLESTR pstrName, DWORD dwReturnMask, IUnknown** ppunkItem, ITypeInfo** ppTypeInfo);
  STDMETHOD(GetDocVersionString)(BSTR* pbstrVersionString);
  STDMETHOD(OnScriptTerminate)(const VARIANT* pvarResult, const EXCEPINFO* pexcepinfo);
  STDMETHOD(OnStateChange)(SCRIPTSTATE ssScriptState);
  STDMETHOD(OnScriptError)(IActiveScriptError* pase);
  STDMETHOD(OnEnterScript)();
  STDMETHOD(OnLeaveScript)();

//IActiveScriptSiteInterruptPoll
  STDMETHOD(QueryContinue)();
};

#endif //__XPSCRIPTSITEOBJ_H_
