#ifndef __XPSERVEROBJ_H__
#define __XPSERVEROBJ_H__


#include "resource.h"       // main symbols


/////////////////// Forward reference ////////////////////////
class CRunScriptStoredProcedure;


class ATL_NO_VTABLE CXPServerObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CXPServerObj, &CLSID_XPServer>,
	public IDispatchImpl<IXPServer, &IID_IXPServer, &LIBID_XP_RUNSCRIPTLib>,
  public ISupportErrorInfoImpl<&IID_IXPServer>
{
public:
//Constructors / Destructors
	CXPServerObj();
  ~CXPServerObj();

DECLARE_NO_REGISTRY()
DECLARE_NOT_AGGREGATABLE(CXPServerObj)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CXPServerObj)
  COM_INTERFACE_ENTRY2(IUnknown, IDispatch)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IXPServer)
  COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

//Member variables
  CRunScriptStoredProcedure* m_pESP;
  CSimpleArray<DBINT> m_DescribeDataTypes;
  CSimpleArray<long>  m_DescribeDataLen;
  CSimpleArray<BYTE*> m_DescribeDefaultData;
  CSimpleArray<BYTE*> m_DescribeRowData;

//IXPServer
	STDMETHOD(get_Parameters)(IXPParameters** ppParameters);
	STDMETHOD(Describe)(BSTR ColumnName, XP_DATATYPE DestType, long DestLen, VARIANT Data);
	STDMETHOD(get_BindToken)(BSTR* pVal);
	STDMETHOD(MessageHandler)(long ErrorNum, long Severity, long State, BSTR ErrorText);
	STDMETHOD(get_PField)(XP_PFIELD Field, BSTR* pVal);
	STDMETHOD(get_SessionMessageLCID)(long* pVal);
	STDMETHOD(get_InstanceName)(BSTR* pVal);
	STDMETHOD(SendDone)();
	STDMETHOD(SendDoneWithError)();
	STDMETHOD(SendDoneWithCount)(long Count);
	STDMETHOD(SendDoneWithCountAndError)(long Count);
  STDMETHOD(SendInfoMsg)(BSTR Message, long MsgNum, long Class, long State, long LineNum);
  STDMETHOD(SendErrorMsg)(BSTR Message, long MsgNum, long Class, long State, long LineNum);
	STDMETHOD(SendRow)();
	STDMETHOD(SetColumnData)(long Column, VARIANT Data);
	STDMETHOD(SetUserDefinedType)(long Column, long UserType);
  STDMETHOD(Quit)(VARIANT_BOOL bSuccess);
  STDMETHOD(put_ReturnValue)(VARIANT_BOOL bSuccess);
  STDMETHOD(get_ReturnValue)(VARIANT_BOOL* pVal);
};

#endif //__XPSERVEROBJ_H__
