// XP_RUNSCRIPT.cpp : Implementation of DLL Exports.

// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f XP_RUNSCRIPTps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "XP_RUNSCRIPT.h"
#include "XP_RUNSCRIPT_i.c"
#include "XP_RunScriptProcs.h"
#include "XPServerObj.h"
#include "XPParametersObj.h"
#include "XPParameterObj.h"


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
END_OBJECT_MAP()

//Note that we do not use the standard XP++ macro IMPLEMENT_XP because we want to perform
//some non standard ATL code at the start of the Extended stored Procedure function
//IMPLEMENT_XP(XP_RUNSCRIPT, CRunScriptStoredProcedure). The first few lines of code is the 
//custom bit over and above a standard IMPLEMENT_XP style XP. This code is used to ensure the 
//type lib info is precached before we call XP_MEM_STATE(beginMemState)
#define IMPLEMENT_XP_RUNSCRIPT(xpName, class) \
  extern "C" SRVRETCODE __declspec(dllexport) xpName(SRV_PROC* srvproc) \
  { \
    CComObjectStackWithQI<CXPServerObj> serverObj; \
    CComPtr<ITypeInfo> serverObjTypeInfo; \
    serverObj.GetTypeInfo(0, LOCALE_SYSTEM_DEFAULT, &serverObjTypeInfo); \
    \
    CComObjectStackWithQI<CXPParametersObj> parametersObj; \
    CComPtr<ITypeInfo> parametersObjTypeInfo; \
    parametersObj.GetTypeInfo(0, LOCALE_SYSTEM_DEFAULT, &parametersObjTypeInfo); \
    \
    CComObjectStackWithQI<CXPParameterObj> parameterObj; \
    CComPtr<ITypeInfo> parameterObjTypeInfo; \
    parameterObj.GetTypeInfo(0, LOCALE_SYSTEM_DEFAULT, &parameterObjTypeInfo); \
    \
    XP_MEM_STATE(beginMemState) \
    \
    SRVRETCODE retCode = 0; \
    { \
      class _xp; \
      retCode = _xp.main(srvproc, #xpName); \
    } \
    \
    XP_MEM_DIFF(beginMemState) \
    \
    return retCode; \
  }


IMPLEMENT_VERSION_XP()                                //Support the optional __GetXpVersion function
IMPLEMENT_XP_RUNSCRIPT(XP_RUNSCRIPT_DISK,      CRunScriptDiskStoredProcedure);
IMPLEMENT_XP_RUNSCRIPT(XP_RUNSCRIPT_PARAMETER, CRunScriptParameterStoredProcedure);
IMPLEMENT_XP_RUNSCRIPT(XP_RUN_ACTIVEX,         CRunActiveXStoredProcedure);


//DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
  if (dwReason == DLL_PROCESS_ATTACH)
  {
    _Module.Init(ObjectMap, hInstance, &LIBID_XP_RUNSCRIPTLib);
    DisableThreadLibraryCalls(hInstance);
  }
  else if (dwReason == DLL_PROCESS_DETACH)
    _Module.Term();

  return TRUE;
}

STDAPI DllCanUnloadNow(void)
{
  return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
  return _Module.GetClassObject(rclsid, riid, ppv);
}

//DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
  //registers object, typelib and all interfaces in typelib
  return _Module.RegisterServer(TRUE);
}

//DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
  return _Module.UnregisterServer(TRUE);
}

